<?php
/**
 * This is a standalone page to save a file.  All globals/constants on the index.php
 * page should be declared here so that no errors occur.
 */
define("ROOTDIR", dirname(__FILE__)); // Global Constant of root directory

require_once(ROOTDIR."/config/class.Config.php");
$config = new Config(); // All configuration variables are contained in this object

require_once(ROOTDIR."/include/database/class.BanQueries.php");
require_once(ROOTDIR."/include/objects/class.BannedUser.php");
require_once(ROOTDIR."/include/php4functions.php");

$allBans = $_POST['allBans'];
$permaBans = $_POST['permaBans'];
$saveSQL = $_POST['saveSQL'];
$demosOnly = $_POST['demosOnly'];

if($allBans == 1) {
  $all = true;
} else {
  $all = false;
}

if($demosOnly == 1) {
  $demosOnly = true;
} else {
  $demosOnly = false;
}

if($saveSQL == 1) {
  $saveSQL = true;
} else {
  $saveSQL = false;
}

if($saveSQL) {
  $filename = $config->siteName."_banned_users.xml";
  header("Content-type: text/xml charset=UTF-8");
} else {
  $filename = $config->siteName."_banned_users.cfg";
  header("Content-type: text/plain");
}

$header = "Content-Disposition: attachment; filename=\"".$filename."\"";
header($header);

$banQueries = new BanQueries();

$bannedUsers = $banQueries->downloadActiveBans($all, $demosOnly);

if($saveSQL) {
?>
<?echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>";?>

<GlobalBans>
<?php
foreach($bannedUsers as $bannedUser) {
?>
  <Ban>
    <SteamID><?=$bannedUser->getSteamId()?></SteamID>
    <IP><?=$bannedUser->getIp()?></IP>
    <Name><?=undoUnwantedConvert(utf8_to_html(convertXmlSpecial(stripslashes($bannedUser->getName()))))?></Name>
    <Length><?=$bannedUser->getLength()?></Length>
    <TimeScale><?=$bannedUser->getTimeScale()?></TimeScale>
    <AddDate><?=$bannedUser->getAddDate()?></AddDate>
    <ExpireDate><?=$bannedUser->getExpireDate()?></ExpireDate>
    <Webpage><?=$config->siteUrl?></Webpage>
  </Ban>
<?php
}
?></GlobalBans><?php
} else {
// Empty line after banid print is needed to force a new line
foreach($bannedUsers as $bannedUser) {
?>
banid <?=$bannedUser->getLength()?> <?=$bannedUser->getSteamId()?>

<?php
}
}

function convertXmlSpecial($string) {
  $string = str_replace("&", "&amp;", $string);
  $string = str_replace("'", "&apos;", $string);
  $string = str_replace("\"", "&quot;", $string);
  $string = str_replace("<", "&lt;", $string);
  $string = str_replace(">", "&gt;", $string);
  return $string;
}

function utf8_to_html($data) {
  return preg_replace("/([\\xC0-\\xF7]{1,1}[\\x80-\\xBF]+)/e", '_utf8_to_html("\\1")', $data);
}

function _utf8_to_html($data) {
  $ret = 0;
  foreach((str_split(strrev(chr((ord($data{0}) % 252 % 248 % 240 % 224 % 192) + 128) . substr($data, 1)))) as $k => $v)
      $ret += (ord($v) % 128) * pow(64, $k);
  return "&#$ret;";
}

function undoUnwantedConvert($string) {
  $string = str_replace("&amp;#", "&#", $string);
  return $string;
}

?>
